#include <iostream>

using namespace std;

class Singleton;
class Singleton {
	static Singleton* s;
	int value;
	Singleton() : value(42) {}
public:
	static Singleton* getInstance() {
		if (!s)
			s = new Singleton();
		return s;
	}
	int getValue() { return value; }
	void setValue(int v) { value = v; }
};
Singleton* Singleton::s = 0;

int
main () {
	cout << "Value = " << Singleton::getInstance()->getValue() << " (should be 42)" << endl;
	Singleton::getInstance()->setValue(13);
	cout << "Value = " << Singleton::getInstance()->getValue() << " (should be 13)" << endl;
	return 0;
}
